<?php
/**
 * F؃vOC
 *
 * @package Joomla!
 * @subpackage plugin_authentication_kingoyya
 * @author EiEp
 * @date 2009-12-08
 * @copyright Copyright (C) 2009 ^
 * @license GNU General Public License
 * @authorEmail info@kingyoya.org
 * authorUrl>http://www.kingyoya.org/
 * version 1.0.0
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * F؃vOC
 */
class plgAuthenticationKingyoya extends JPlugin
{

	/**
	 * Constructor
	 *
	 */
	function plgAuthenticationKingyoya(& $subject, $config) {
		parent::__construct($subject, $config);
	}

	/**
	 * This method should handle any authentication and report back to the subject
	 *
	 * @access	public
	 * @param   array 	$credentials Array holding the user credentials
	 * @param 	array   $options     Array of extra options
	 * @param	object	$response	 Authentication response object
	 * @return	boolean
	 * @since 1.5
	 */
	function onAuthenticate( &$credentials, $options, &$response ) {
		$params = $this->params;
		$email_login = (boolean) $params->get('email_login');

		if (!$email_login) {
			$response->status = JAUTHENTICATE_STATUS_CANCEL;
			return;
		}

		jimport('joomla.user.helper');

		// Joomla does not like blank passwords
		if (empty($credentials['password']))
		{
			$response->status = JAUTHENTICATE_STATUS_FAILURE;
			$response->error_message = 'Empty password not allowed';
			return false;
		}

		// Initialize variables
		$conditions = '';

		// Get a database object
		$db =& JFactory::getDBO();

		$username = $db->Quote( $credentials['username'] );
		$query = 'SELECT `id`, `password`, `gid`'
			. ' FROM `#__users`'
			. ' WHERE email = '. $username
			;
		$db->setQuery( $query );
		$result = $db->loadObject();


		if($result) {
			$parts	= explode( ':', $result->password );
			$crypt	= $parts[0];
			$salt	= @$parts[1];
			$testcrypt = JUserHelper::getCryptedPassword($credentials['password'], $salt);

			if ($crypt == $testcrypt) {
				$user = JUser::getInstance($result->id); // Bring this in line with the rest of the system
				$response->email = $user->email;
				$response->fullname = $user->name;
				$response->status = JAUTHENTICATE_STATUS_SUCCESS;
				$response->error_message = '';
				$credentials['username'] = $user->username;
			} else {
				$response->status = JAUTHENTICATE_STATUS_FAILURE;
				$response->error_message = 'Invalid password';
			}
		}
		else
		{
			$response->status = JAUTHENTICATE_STATUS_FAILURE;
			$response->error_message = 'User does not exist';
		}
	}
}
